
.data
All            db  '[-All-]',0
TabTitle1      db  'Views',0
TabTitle2      db  'Settings',0
TabTitle3      db  'Font/Color',0
TabTitle4      db  'Edit &Pgm',0
TabTitle5      db  'Pack/UnPack',0
szStatic1      db  'Font Face and Size:', 0
szStatic2      db  'Text Color:', 0
szStatic3      db  'Text Back Ground Color:', 0
szStatic4      db  'Back Ground Color:', 0

.data?
hTab           dd  ?
hTabSeL1       dd  ?
hTabSeL2       dd  ?
hTabSeL3       dd  ?
hTabSeL4       dd  ?
hTabSeL5       dd  ?
hFocus         dd  ?

TabSelect      dd  ?

sw4            dd  ?
ShowGrid       dd  ?
SaveOnExit     dd  ?
SavList        dd  ?
ShowHidden     dd  ?
ShowConfC      dd  ?
ShowConfD      dd  ?
ShowProcessed  dd  ?
ShowProgess    dd  ?
CopyToRecycle  dd  ?

SaveCode       dd  ?
ColorRes       dd  ?
IncrRes        dd  ?

tci            TC_ITEM              <?>

.code

;===================================================
; Tab Control Procedure
;===================================================
TabCtlDlg PROC uses ebx hdlg:DWORD, wMsg, wParam, lParam

      .if wMsg == WM_INITDIALOG
         INVOKE     GetDlgItem, hdlg, 702            ; Get the handle of the Tab Control
            mov     hTab, eax                        ; Save it

;----------------- [Fill the Tab Control Item structure and insert the item] --------------------

            mov     tci.imask, TCIF_TEXT             ; Text
            mov     tci.lpReserved1, 0               ; Reserved
            mov     tci.lpReserved2, 0               ; Reserved
            mov     tci.pszText, offset TabTitle1    ; pointer to string containing tab text 
            mov     tci.cchTextMax, sizeof TabTitle1 ; Size of TabTitle1
            mov     tci.iImage, -1                   ; Index to tab control's image 
            mov     tci.lParam, 0                    ; Extra info
         INVOKE     SendMessage, hTab, TCM_INSERTITEM, 0, offset tci

            mov     tci.pszText, offset TabTitle2
            mov     tci.cchTextMax, sizeof TabTitle2
         INVOKE     SendMessage, hTab, TCM_INSERTITEM, 1, addr tci

            mov     tci.pszText, offset TabTitle3
            mov     tci.cchTextMax, sizeof TabTitle3
         INVOKE     SendMessage, hTab, TCM_INSERTITEM, 2, addr tci

            mov     tci.pszText, offset TabTitle4
            mov     tci.cchTextMax, sizeof TabTitle4
         INVOKE     SendMessage, hTab, TCM_INSERTITEM, 3, addr tci

            mov     tci.pszText, offset TabTitle5
            mov     tci.cchTextMax, sizeof TabTitle5
         INVOKE     SendMessage, hTab, TCM_INSERTITEM, 4, addr tci

;----------------- [Load the dialog boxes in the Tab Controls] --------------------

         INVOKE     CreateDialogParam, hInst, IDD_VIEW, hTab, offset ViewDlg, 0
            mov     hTabSeL1, eax

         INVOKE     CreateDialogParam, hInst, IDD_SETTINGS, hTab, offset SettingsDlg, 0
            mov     hTabSeL2, eax

         INVOKE     CreateDialogParam, hInst, IDD_COLORFONT, hTab, offset ColorFontDlg, 0
            mov     hTabSeL3, eax

         INVOKE     CreateDialogParam, hInst, IDD_EDIT, hTab, offset EditZipDlg, 0
            mov     hTabSeL4, eax

         INVOKE     CreateDialogParam, hInst, IDD_ZIP, hTab, offset EditZipDlg, 0
            mov     hTabSeL5, eax

         INVOKE     SendMessage, hTab, TCM_SETCURSEL, TabSelect, 0
            mov     eax, TabSelect                    ; Previous selected Tab
            mov     ebx, hTabSeL1+[eax*4]             ; Extract previous Tabs handle
         INVOKE     ShowWindow, ebx, SW_SHOWDEFAULT
INVOKE     SetFocus, hFocus
            jmp     GetOut

      .elseif wMsg ==  WM_NOTIFY
            mov     eax, lParam                      ; lParam is a pointer to a NMHDR Struct
            mov     eax, (NMHDR ptr [eax]).code      ; Check for TCN_SELCHANGE notify message
         .if eax == TCN_SELCHANGE
               jmp     SelectTab
         .endif

      .elseif wMsg ==  WM_CLOSE
            jmp     CancelOut

      .elseif wMsg ==  WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh
         .if eax == IDCANCEL
               jmp     CancelOut
         .endif
      .endif
         jmp     GetOut

SelectTab:
         mov     ebx, TabSelect                          ; Previous selected Tab
         mov     eax, hTabSeL1+[ebx*4]                   ; Extract previous Tabs handle
      INVOKE     ShowWindow, eax, SW_HIDE                ; Hide its window
      INVOKE     SendMessage, hTab, TCM_GETCURSEL, 0, 0  ; New selected Tab
         mov     TabSelect, eax                          ; Save the Tab ID
         mov     ebx, hTabSeL1+[eax*4]                   ; Extract new Tabs handle
      INVOKE     ShowWindow, ebx, SW_SHOWDEFAULT         ; Show its window
      .if TabSelect ==2
         INVOKE     SendMessage, hTabSeL3, WM_COMMAND, 200, 0
      .endif
         jmp     GetOut

CancelOut:
;      INVOKE     EndDialog, hdlg, wParam
      INVOKE     DestroyWindow, hTabSeL1
      INVOKE     DestroyWindow, hTabSeL2
      INVOKE     DestroyWindow, hTabSeL3
      INVOKE     DestroyWindow, hTabSeL4
      INVOKE     DestroyWindow, hTabSeL5
      INVOKE     DestroyWindow, hdlg
         mov     eax, TRUE
         jmp     ConfgRet

GetOut:
         mov     eax, FALSE

ConfgRet:
         ret

TabCtlDlg ENDP

;===================================================
; Different views Procedure
;===================================================
ViewDlg PROC  uses ebx  hdlg:DWORD, wMsg, wParam, lParam
LOCAL     rect:RECT

      .if wMsg == WM_INITDIALOG
            mov     eax, ViewFlag
         INVOKE     GetDlgItem, hdlg, eax
         INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
            mov     ecx, BST_UNCHECKED
         .if EqualOn
               mov     ecx, BST_CHECKED
         .endif
         INVOKE     SendDlgItemMessage, hdlg, 313, BM_SETCHECK, ecx, 0
         INVOKE     GetDlgItem, hdlg, 105
            mov     hFocus, eax

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh

; 309 = Two List views
; 310 = Tree view and Two list views
; 311 = One list view
; 312 = Tree view and One list view

         .if eax > 308 && eax < 313
              push     ViewFlag
              push     eax
               mov     eax, ViewFlag
            INVOKE     GetDlgItem, hdlg, eax
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_UNCHECKED, 0
               pop     eax
               mov     ViewFlag, eax
            INVOKE     GetDlgItem, hdlg, eax
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
               xor     eax, eax
            .if ViewFlag == 310 || ViewFlag == 312
                  mov     eax, 1
            .endif
            INVOKE     SendMessage, hWndListL, CM_SETTREE, SplitV[4], eax
              push     ActiveList
            .if ViewFlag == 311 || ViewFlag == 312
                  and     ActiveList, 0
               INVOKE     SetFocus, hWndListL
            .endif
               pop     ecx
               pop     eax
            .if eax != ViewFlag
;               .if ecx
                    call     TreeBranch
;               .endif
;               INVOKE     DoSHNotify, 1, SHCNE_CREATE

DoSize:
               INVOKE     GetClientRect, hWnd, addr rect
                  mov     eax, rect.bottom
                  shl     eax, 16
                  mov     ebx, rect.right
                  mov     ax, bx
               INVOKE     PostMessage, hWnd, WM_SIZE, 0, eax       ; Send width & height to hWnd
               INVOKE     SendMessage, hWndListL, CM_REDRAW, 0, 0
               INVOKE     SendMessage, hWndListR, CM_REDRAW, 0, 0
            .endif

         .elseif eax == 313
            INVOKE     IsDlgButtonChecked, hdlg, 313
               mov     EqualOn, eax
            .if eax
                  jmp     DoSize
            .endif
         .endif
      .endif

GetOut:
         mov     eax, FALSE
         ret

ViewDlg ENDP

;===================================================
; Settings Procedure
;===================================================
SettingsDlg PROC hdlg:DWORD, wMsg, wParam, lParam
 
      .if wMsg == WM_INITDIALOG
         .if ShowGrid == 1
            INVOKE     GetDlgItem, hdlg, 309
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if ShowHidden == 1
            INVOKE     GetDlgItem, hdlg, 310
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if ShowConfC == 1
            INVOKE     GetDlgItem, hdlg, 311
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if ShowConfD == 1
            INVOKE     GetDlgItem, hdlg, 312
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if ShowProgess == 1
            INVOKE     GetDlgItem, hdlg, 313
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if ShowProcessed == 1
            INVOKE     GetDlgItem, hdlg, 314
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if SaveOnExit == 1
            INVOKE     GetDlgItem, hdlg, 315
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         .if CopyToRecycle == 1
            INVOKE     GetDlgItem, hdlg, 316
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh
         .if eax > 308 && eax < 317         ; Hidden files, Processed message, Save on exit, etc.
            INVOKE     IsDlgButtonChecked, hdlg, wParam
            .if eax == BST_CHECKED
               INVOKE     GetDlgItem, hdlg, wParam
               INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
               .if wParam == 309
                     mov     ShowGrid, 1
               .elseif wParam == 310
                     mov     ShowHidden, 1
               .elseif wParam == 311
                     mov     ShowConfC, 1
               .elseif wParam == 312
                     mov     ShowConfD, 1
               .elseif wParam == 313
                     mov     ShowProgess, 1
               .elseif wParam == 314
                     mov     ShowProcessed, 1
               .elseif wParam == 315
                     mov     SaveOnExit, 1
               .elseif wParam == 316
                     mov     CopyToRecycle, 1
               .endif

            .else
               INVOKE     GetDlgItem, hdlg, wParam
               INVOKE     SendMessage, eax, BM_SETCHECK, BST_UNCHECKED, 0
               .if wParam == 309
                     and     ShowGrid, 0
               .elseif wParam == 310
                     and     ShowHidden, 0
               .elseif wParam == 311
                     and     ShowConfC, 0
               .elseif wParam == 312
                     and     ShowConfD, 0
               .elseif wParam == 313
                     and     ShowProgess, 0
               .elseif wParam == 314
                     and     ShowProcessed, 0
               .elseif wParam == 315
                     and     SaveOnExit, 0
               .elseif wParam == 316
                     and     CopyToRecycle, 0
               .endif
            .endif
            .if wParam == 309      ; Show/Hide grid lines
               INVOKE     SendMessage, hWndListL, CM_SETGRIDLINES, ShowGrid, 0
               INVOKE     SendMessage, hWndListR, CM_SETGRIDLINES, ShowGrid, 0

            .elseif wParam == 310  ; Show/Hide hidden/system files
               INVOKE     DoSHNotify, 1, SHCNE_CREATE
            .endif
         .endif
      .endif

GetOut:

         mov     eax, FALSE
         ret
SettingsDlg ENDP

;===================================================
; Color And Font Procedure
;===================================================
ColorFontDlg PROC uses ebx esi edi hdlg:DWORD, wMsg, wParam, lParam
LOCAL    cf:CHOOSEFONT
LOCAL    cc:CHOOSECOLOR
LOCAL    cm:COLORMAP
LOCAL    rect:RECT
LOCAL    hDC:DWORD, Ctrl, Incr, hNewBrush, Cnt, Cnt1, Len, hTemp, ID 

      .if wMsg == WM_INITDIALOG
         INVOKE     GetDlgItem, hdlg, 802
            mov     hTemp, eax
         INVOKE     EnableWindow, hTemp, 0

      .elseif wMsg == WM_PAINT || wMsg == WM_MOVE
         INVOKE     PostMessage, hTabSeL3, WM_COMMAND, 200, 0

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh
         .if eax == 200
              call     PaintColors

         .elseif eax > 200 && eax < 211
               mov     SaveCode, eax
               sub     eax, 201
               mov     edi, eax
               mov     esi, Color.SelBarF[eax*4]
              call     DoColor

ResetChg:
         .elseif eax == 801                 ; Defaults
               lea     esi, DefaultColor
               lea     edi, Color.SelBarF
               mov     ecx, 10 ;12
            .while (ecx)
                  mov     eax, dword ptr[esi]
                  mov     dword ptr[edi], eax
                  add     esi, 4
                  add     edi, 4
                  dec     ecx
            .endw
              call     SetColors
            INVOKE     RedrawWindow, hdlg, 0, 0, RDW_ERASE or RDW_INVALIDATE or RDW_UPDATENOW
              call     DoWindow
              call     PaintColors

         .elseif eax == 802 && SaveCode     ; Undo last change
               mov     esi, ColorRes
               mov     edi, IncrRes
               mov     eax, SaveCode
               mov     wParam, eax
            INVOKE     GetDlgItem, hdlg, 802
               mov     hTemp, eax
            INVOKE     EnableWindow, hTemp, 0
              call     UndoChg
               and     SaveCode, 0
         .endif
      .endif
         jmp     ColorDone

DoWindow:

PaintColors:
         xor     esi, esi
         mov     Ctrl, 201
         mov     Cnt, 10
      .while (Cnt)
         INVOKE     GetDlgItem, hdlg, Ctrl
            mov     hTemp, eax
         INVOKE     GetDC, hTemp
            mov     hDC, eax
         INVOKE     CreateSolidBrush, Color.SelBarF[esi]
            mov     hNewBrush, eax
         INVOKE     GetClientRect, hTemp, addr rect
         INVOKE     FillRect, hDC, addr rect, hNewBrush
         INVOKE     DeleteObject, hNewBrush
;         INVOKE     DeleteDC, hDC
         INVOKE     ReleaseDC, hTemp, hDC
            add     esi, 4
            inc     Ctrl
            dec     Cnt
      .endw
      INVOKE     UpdateWindow, hTabSeL3
        retn

DoColor:
;---------- [Set the CHOOSECOLOR attributes] ----------
      .if SaveCode
         INVOKE     GetDlgItem, hdlg, 802
            mov     hTemp, eax
         INVOKE     EnableWindow, hTemp, 1
      .endif
         mov     ColorRes, esi
         mov     IncrRes, edi
         mov     edx, esi
         and     esi, 00ffffffh
         and     edx, 0ff000000h
        push     edx
      INVOKE     RtlZeroMemory, addr cc, sizeof cc
         mov     cc.lStructSize, sizeof cc
         mov     eax, hWnd
         mov     cc.hwndOwner, eax
         mov     eax, hInst
         mov     cc.hInstance, eax
         mov     cc.rgbResult, esi
         mov     cc.lpCustColors, offset CustClrs
         mov     cc.Flags, CC_FULLOPEN or CC_RGBINIT
      INVOKE     ChooseColor, addr cc
         pop     edx
      .if !eax                                ; Cancel'ed or error occurred
         INVOKE     SetFocus, hTabSeL3
           call     PaintColors
            jmp     ColorRet
      .endif
         mov     esi, cc.rgbResult
         add     esi, edx

UndoChg:
         mov     Color.SelBarF[edi*4], esi

SetColors:
      .if SaveCode == 201
            and     SelBarMask, 0
            xor     ecx, ecx
         .while (ecx < 4)
            .if byte ptr Color.SelBarF[ecx] == 0ffh
                  mov     byte ptr Color.SelBarF[ecx], 0feh
                  mov     SelBarMask, 00010101h
            .endif
            .if byte ptr Color.SelBarF[ecx]
               mov     byte ptr SelBarMask[ecx], 1
         .endif
            inc     ecx
         .endw
         .if !SelBarMask
               mov     SelBarMask, 00010101h
         .endif
      .endif

        push     ActiveList
         mov     ActiveList, 0
        call     SetColorFont
         mov     ActiveList, 1
        call     SetColorFont
         pop     ActiveList
      INVOKE     RedrawWindow, hTabSeL3, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT
      INVOKE     UpdateWindow, hTabSeL3

      .if SaveCode == 203
         INVOKE     ImageList_Destroy, hImageListTree
         INVOKE     ImageList_Create, 16, 16, ILC_COLOR16, 7, 10
            mov     hImageListTree, eax
            mov     cm.From, 00ffffffh
            mov     eax, Color.TreeBC
            mov     cm.To, eax
         INVOKE     CreateMappedBitmap, hInst, 8002, 0, addr cm, 1
           push     eax
         INVOKE     ImageList_Add, hImageListTree, eax, NULL
            pop     eax
         INVOKE     DeleteObject, eax
      .endif

      INVOKE     RedrawWindow, hWnd, 0, 0, RDW_INVALIDATE or RDW_INTERNALPAINT
      INVOKE     SendMessage, hWndTree, TVM_SETTEXTCOLOR, 0, Color.TreeTC
      INVOKE     SendMessage, hWndTree, TVM_SETBKCOLOR, 0, Color.TreeBC
;      INVOKE     SetFocus, hTabSeL3
        retn

ColorDone:
         mov     eax, FALSE              ; Return with FALSE

ColorRet:
         ret

ColorFontDlg ENDP

;===================================================
; Edit and Zip programs Procedure
;===================================================
EditZipDlg PROC hdlg:DWORD, wMsg, wParam, lParam
LOCAL    ofn:OPENFILENAME
LOCAL    szBuff[256]:BYTE

      .if wMsg == WM_INITDIALOG
         .if ChkZip == 1
            INVOKE     GetDlgItem, hdlg, 444
            INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
         .endif
         INVOKE     SetDlgItemText, hdlg, 800, addr szZipPack
         INVOKE     SetDlgItemText, hdlg, 801, addr szZipUnPack
         INVOKE     SetDlgItemText, hdlg, 802, addr szPgmZip
         INVOKE     SetDlgItemText, hdlg, 803, addr szEditPgr

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh

         .if eax > 9 && eax < 14         ; Browse for Edit, Pack, or UnPack programs
               mov     szBuff, 0
            INVOKE     RtlZeroMemory, addr ofn, sizeof ofn
               mov     ofn.lStructSize, sizeof ofn
             MOVmd     ofn.hwndOwner, hWnd
             MOVmd     ofn.hInstance, hInst
               mov     ofn.lpstrFilter, offset szExeOpen
               lea     eax, szBuff
               mov     ofn.lpstrFile, eax
               mov     ofn.nMaxFile, lengthof szBuff
               mov     ofn.lpstrInitialDir, 0
               mov     ofn.lpstrTitle, 0
               mov     ofn.Flags, OFN_PATHMUSTEXIST or OFN_FILEMUSTEXIST
               mov     ofn.lpstrDefExt, 0
            INVOKE     GetOpenFileName, addr ofn
               cmp     eax, FALSE       ;Cancel'ed or error occurred
                je     GetOut
               mov     eax, wParam
               add     eax, 790
               mov     ecx, eax
            INVOKE     SetDlgItemText, hdlg, ecx, addr szBuff
            .if wParam == 10
               INVOKE     lstrcpy, addr ZipPack, addr szBuff
            .elseif wParam == 11
                INVOKE     lstrcpy, addr szZipUnPack, addr szBuff
            .elseif wParam == 12
                INVOKE     lstrcpy, addr szPgmZip, addr szBuff
            .elseif wParam == 13
                INVOKE     lstrcpy, addr szEditPgr, addr szBuff
            .endif

         .elseif eax == 444
            INVOKE     IsDlgButtonChecked, hdlg, wParam
            .if eax == BST_CHECKED
               INVOKE     GetDlgItem, hdlg, wParam
               INVOKE     SendMessage, eax, BM_SETCHECK, BST_CHECKED, 0
                  mov     ChkZip, 1
            .else
                  and     ChkZip, 0
            .endif
         .endif
      .endif

GetOut:
         mov     eax, FALSE
         ret

EditZipDlg   ENDP

;===================================================
; Find folders, files, and string Procedure
;===================================================
FindDlg PROC uses ebx esi hdlg:DWORD, wMsg, wParam, lParam
LOCAL    rect:RECT
LOCAL    szBuff[256]:BYTE

      .if wMsg == WM_INITDIALOG
         INVOKE     GetDlgItem, hdlg, 844
            mov     hCombo, eax
         INVOKE     SendMessage, hCombo, WM_SETFONT, hFontL, TRUE
         INVOKE     SendMessage, hCombo, CB_DIR, DDL_DRIVES or DDL_EXCLUSIVE, addr szAllFiles
         INVOKE     SendMessage, hCombo, CB_INSERTSTRING, 0, addr All
         INVOKE     SendMessage, hCombo, CB_SETCURSEL, 0, 0
         INVOKE     SendMessage, hCombo, CB_SETITEMHEIGHT, -1, 15
         INVOKE     SendMessage, hCombo, CB_SETITEMHEIGHT, 1, 15

      .elseif wMsg == WM_COMMAND
            mov     eax, wParam
            and     eax, 0ffffh
         .if eax > 12 && eax < 16         ; Find buttons
               mov     szBuff, 0
               mov     eax, wParam
               add     eax, 790
               mov     ecx, eax
            INVOKE     GetDlgItemText, hdlg, ecx, addr szFoldFile, sizeof szFoldFile
            .if !eax
                  jmp     GetOut
            .endif

            INVOKE     SendMessage, hCombo, CB_GETCURSEL, 0, 0
               mov     ecx, eax
               mov     ebx, 1
            .if eax
               INVOKE     SendMessage, hCombo, CB_GETLBTEXT, ecx, addr szBuff
                  xor     ebx, ebx
                  mov     bl, byte ptr szBuff+2
                  sub     bl, 20h
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, 845
               xor     esi, esi
            .if eax == BST_CHECKED
                  mov     esi, 1
            .endif
            INVOKE     IsDlgButtonChecked, hdlg, 846
            INVOKE     FindFoldFile, wParam, ebx, esi, eax
         .endif

      .elseif wMsg == WM_CLOSE
;         INVOKE     EndDialog, hdlg, wParam
         INVOKE     DestroyWindow, hdlg     ; End the dialog
         INVOKE     SetFocus, hWnd
            mov     eax, TRUE
            jmp     DlgRet
      .endif

GetOut:
         mov     eax, FALSE

DlgRet:
         ret

FindDlg   ENDP

