
            include  Windows.inc
            include  user32.inc
            include  kernel32.inc
            include  gdi32.inc
            include  comctl32.inc
            include  comdlg32.inc
            include  imagehlp.inc
            include  ole32.inc
            include  olepro32.inc
            include  shell32.inc
            include  advapi32.inc

   include  L:\AsmEdit\include\DSPMACRO.asm

         includelib  user32.lib
         includelib  kernel32.lib
         includelib  gdi32.lib
         includelib  comctl32.lib
         includelib  comdlg32.lib
         includelib  imagehlp.lib
         includelib  ole32.lib
         includelib  olepro32.lib
         includelib  shell32.lib
         includelib  advapi32.lib

            include  oaidl.inc
            include  shlobj.inc

;===================================================
; PROTO, MACRO, and Data section
;===================================================
WinMain         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
AsciiBase       PROTO  :DWORD, :DWORD, :DWORD
BaseAscii       PROTO  :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :DWORD
FillBuffer      PROTO  :DWORD, :DWORD, :BYTE, :DWORD
StatusBar       PROTO  :DWORD, :DWORD, :DWORD, :DWORD
ChgBmpColor     PROTO  :DWORD
InitTree        PROTO  :DWORD, :DWORD
FillTree        PROTO  :DWORD, :DWORD
GetDrive        PROTO  :DWORD
PathToPidl      PROTO  :DWORD
ThreadProc      PROTO
ChangeProc      PROTO
DoSHNotify      PROTO  :DWORD, :DWORD
AbVerDlg        PROTO  :DWORD, :DWORD, :DWORD, :DWORD
ConfirmDlg      PROTO  :DWORD, :DWORD, :DWORD, :DWORD
CopyDlg         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
DupeDlg         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
ColorFontDlg    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
TabCtlDlg       PROTO  :DWORD, :DWORD, :DWORD, :DWORD
ViewDlg         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SettingsDlg     PROTO  :DWORD, :DWORD, :DWORD, :DWORD
EditZipDlg      PROTO  :DWORD, :DWORD, :DWORD, :DWORD
FindDlg         PROTO  :DWORD, :DWORD, :DWORD, :DWORD
SplitBarProc    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
FindFoldFile    PROTO  :DWORD, :DWORD, :DWORD, :DWORD
PackUnpack      PROTO  :DWORD, :DWORD, :DWORD
ChkSplitter     PROTO  :DWORD, :DWORD
RegQuerySZ      PROTO  :DWORD, :DWORD
RegQuery        PROTO  :DWORD, :DWORD
RegSetSZ        PROTO  :DWORD, :DWORD

TBSep    MACRO hTool
           mov     tbb.iBitmap, 0
           mov     tbb.idCommand, 0
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_SEP
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

TBButt   MACRO hTool, BmpID, CmdID, Text
           mov     tbb.iBitmap, BmpID    ; Button image number
           mov     tbb.idCommand, CmdID  ; Command ID number
           mov     tbb.fsState, TBSTATE_ENABLED
           mov     tbb.fsStyle, TBSTYLE_BUTTON
           mov     tbb.dwData, 0
           mov     tbb.iString, Text
        INVOKE     SendMessage, hTool, TB_ADDBUTTONS, 1, addr tbb
          ENDM

MOVmd    MACRO Var1, Var2
          push     Var2
           pop     Var1
          ENDM

MOVmw    MACRO Var1, Var2
           lea     esi, Var2
           lea     edx, Var1
           REPEAT     2
              mov     al, [esi]
              mov     [edx], al
              inc     esi
              inc     edx
             ENDM
          ENDM

; Messages
CM_ADDCOL          equ WM_USER+1  ; wParam=0, lParam=lpCOLUMN
CM_ADDROW          equ WM_USER+2  ; wParam=0, lParam=lpROWDATA (can be NULL)
CM_SETCURSEL       equ WM_USER+3  ; wParam=nCol, lParam=nRow
CM_GETCURCOL       equ WM_USER+4  ; wParam=0, lParam=0
CM_GETCURROW       equ WM_USER+5  ; wParam=0, lParam=0
CM_GETCELLDATA     equ WM_USER+6  ; wParam=nRowCol, lParam=lpData
CM_SETCELLDATA     equ WM_USER+7  ; wParam=nRowCol, lParam=lpData
CM_GETCELLRECT     equ WM_USER+8  ; wParam=nRowCol, lParam=lpRECT
CM_SCROLLLIST      equ WM_USER+9  ; wParam=0, lParam=0
CM_ENTEREDIT       equ WM_USER+10 ; wParam=nCol, lParam=nRow
CM_ENDEDIT         equ WM_USER+11 ; wParam=nRowCol, lParam=fCancel
CM_GETCOLWIDTH     equ WM_USER+12 ; wParam=nCol, lParam=0
CM_SETCOLWIDTH     equ WM_USER+13 ; wParam=nCol, lParam=nWidth
CM_GETHDRHEIGHT    equ WM_USER+14 ; wParam=0, lParam=0
CM_SETHDRHEIGHT    equ WM_USER+15 ; wParam=0, lParam=nHeight
CM_GETROWHEIGHT    equ WM_USER+16 ; wParam=0, lParam=0
CM_SETROWHEIGHT    equ WM_USER+17 ; wParam=0, lParam=nHeight
CM_RESETCONTENT    equ WM_USER+18 ; wParam=0, lParam=0
CM_COLUMNSORT      equ WM_USER+19 ; wParam=nCol, lParam=0=Ascending, 1=Descending, 2=Invert
CM_GETHDRTEXT      equ WM_USER+20 ; wParam=nCol, lParam=lpBuffer
CM_SETHDRTEXT      equ WM_USER+21 ; wParam=nCol, lParam=lpszText
CM_GETCOLTYPE      equ WM_USER+22 ; wParam=nCol, lParam=0
CM_SETHANDLES      equ WM_USER+23 ; wParam=0, lParam=lpHandles
CM_SETCOLORS       equ WM_USER+24 ; wParam=0, lParam=lpColors
CM_SETFONTS        equ WM_USER+25 ; wParam=hFontC, lParam=hFontL
CM_SETGRIDLINES    equ WM_USER+26 ; wParam=TRUE/FALSE, lParam=0
CM_SETACTIVE       equ WM_USER+27 ; wParam=0, lParam=TRUE/FALSE
CM_DBCLICK         equ WM_USER+28 ; wParam=nCol, lParam=nRow
CM_GETSORT         equ WM_USER+29 ; wParam=0, lParam=0
CM_GETSCROLLPOS    equ WM_USER+30 ; wParam=0, lParam=0
CM_SETSCROLLPOS    equ WM_USER+31 ; wParam=0, lParam=0
CM_CHECKSELECT     equ WM_USER+32 ; wParam=0, lParam=0
CM_LEFTWIDTH       equ WM_USER+33 ; wParam=nWidth, lParam=0
CM_SENDDRAG        equ WM_USER+34 ; wParam=0, lParam=0
CM_SENDDROP        equ WM_USER+35 ; wParam=0, lParam=0
CM_GETSUMCOLWIDTH  equ WM_USER+36 ; wParam=0, lParam=0
CM_SETSELECTALL    equ WM_USER+37 ; wParam=0, lParam=0
CM_CLEARSELECT     equ WM_USER+38 ; wParam=0, lParam=0
CM_INVERTSELECT    equ WM_USER+39 ; wParam=0, lParam=0
CM_CLEAREDIT       equ WM_USER+40 ; wParam=0, lParam=0
CM_REDRAW          equ WM_USER+41 ; wParam=0, lParam=0 +66
CM_SETTREE         equ WM_USER+42 ; wParam=0, lParam=TRUE/FALSE
CM_SETTREEMODE     equ WM_USER+43 ; wParam=0, lParam=TRUE/FALSE

CN_HEADERCLICK     equ 1          ; User clicked header
CN_BUTTONCLICK     equ 2          ; Sent when user clicks the button in a button cell
CN_CHECKCLICK      equ 3          ; Sent when user double clicks the checkbox in a checkbox cell
CN_IMAGECLICK      equ 4          ; Sent when user double clicks the image in an image cell
CN_BEFORESELCHANGE equ 5          ; Sent when user request a selection change
CN_AFTERSELCHANGE  equ 6          ; Sent after a selection change
CN_BEFOREEDIT      equ 7          ; Sent before the cell edit control shows
CN_AFTEREDIT       equ 8          ; Sent when the cell edit control is about to close
CN_BEFOREUPDATE    equ 9          ; Sent before a cell updates grid data
CN_AFTERUPDATE     equ 10         ; Sent after grid data has been updated
CN_USERCONVERT     equ 11         ; Sent when user cell needs to be converted.
CN_DRAG            equ 12         ; Sent when user starts a drag drop
CN_DRAGDROP        equ 13         ; Sent when user completes a drag drop
CN_SETACTIVE       equ 14         ; Sent when user clicks within a listview

; Column alignment
ALIGN_LEFT         equ 0
ALIGN_CENTER       equ 1
ALIGN_RIGHT        equ 2

; Column types
TYPE_EDITTEXT      equ 0          ; String
TYPE_EDITLONG      equ 1          ; Long

; Column sorting
SORT_ASCENDING     equ 0
SORT_DESCENDING    equ 1
SORT_INVERT        equ 2

; Window styles
STYLE_NOSEL        equ 01h
STYLE_NOFOCUS      equ 02h
STYLE_HGRIDLINES   equ 04h
STYLE_VGRIDLINES   equ 08h
STYLE_GRIDFRAME    equ 10h

.const
IDM_ATTRI      equ 401
IDM_ASSOC      equ 402
IDM_VOLUME     equ 403
IDM_PACK       equ 404
IDM_UNPACK     equ 405
IDM_EXIT       equ 406
IDM_SELECT     equ 501
IDM_UNSELECT   equ 502
IDM_INVERT     equ 503
IDM_CONFIG     equ 601
IDM_HELP       equ 801
IDM_ABOUT      equ 802

IDM_COPY       equ 911
IDM_MOVE       equ 912
IDM_RENAME     equ 913
IDM_DELETE     equ 914
IDM_MAKEDIR    equ 915
IDM_FIND       equ 916
IDM_RENAMEE    equ 917
IDM_EXPLODE    equ 940
IDM_TAB        equ 941
IDM_TEST       equ 4444
IDM_COPYMOVE   equ 945
IDM_PASTE      equ 946

IDD_CONFIRM    equ 5000
IDD_COPY       equ 5001
IDD_DUPE       equ 5002
IDD_ATTRI      equ 5005
IDD_ASSOC      equ 5006
IDD_VOLUME     equ 5007
IDD_TABCTL     equ 5008
IDD_VIEW       equ 5013
IDD_SETTINGS   equ 5014
IDD_COLORFONT  equ 5015
IDD_EDIT       equ 5016
IDD_ZIP        equ 5017
IDD_FIND       equ 5018
IDD_SEARCH     equ 5019
IDD_ABOUT      equ 5021

IDC_EDIT40     equ 6001
IDC_TO         equ 6002
IDR_ACCEL      equ 7001

ID_TREEVIEW    equ 8001

WM_SHNOTIFY    equ 4401 ; Window message for shell change notifications

IDM_FIRST      equ FCIDM_SHVIEWFIRST
IDM_LAST       equ IDM_FIRST+100

.data
AppName        db  'File Manager V2 R0',0
CListClass     db  'CListClass',0
ClassName      db  'File Manager V2 R0',0
szCustListDLL  db  'CustList.DLL',0
szShell32      db  'Shell32.dll',0
StatClass      db  'msctls_statusbar32',0
ToolClass      db  'ToolbarWindow32',0
TreeClass      db  'SysTreeView32',0
StaticClass    db  'static',0
ComboClass     db  'combobox',0

szREGSZ        db  'REG_SZ',0
szRedit        db  'Software\EW Software\FileMan V1\',0
WordPath       db  '[Path WordPad]',0
ListPathL      db  '[Path List Left]',0
ListPathR      db  '[Path List Right]',0
szSortL        db  '[Sort List Left]',0
szSortR        db  '[Sort List Right]',0
ZipPack        db  '[Zip Pack]',0
ZipUnPack      db  '[Zip Unpack]',0
PgmZip         db  '[Zip Internal Pgm]',0
EditPgr        db  '[Edit Program]',0
szActive       db  'Active List',0
szCustClrs     db  'Colors Cust',0
szFileManClrs  db  'Colors FileMan',0
szColWth       db  'Column Widths',0
szShowGrid     db  'Flag Show Grid',0
szShowHidden   db  'Flag Show Hidden',0
szShowConfC    db  'Flag Show Conf Copy/Move',0
szShowConfD    db  'Flag Show Conf Delete',0
szShowProgess  db  'Flag Show Progess',0
szShowProcess  db  'Flag Show Processed',0
szSaveOnExit   db  'Flag Save On Exit',0
szCopyToRecyc  db  'Flag Copy To Recycle',0
szViewFlag     db  'Flag Tree List View',0
szChkZip       db  'Flag Check Zip',0
szEqualOn      db  'Flag Equal Size',0
szSplitV       db  'Pos SplitV',0
szWndPos       db  'Pos Window',0

MenuName       db  'MainMenu',0
PopupMenu      db  'PopupMenu',0

FontNameMS     db  'MS Sans Serif',0
FontNameTac    db  'Tahoma',0

szPgmName      db  'Software\Microsoft\Windows\ShellNoRoam\MUICache',0
szFileExts     db  'Software\MicroSoft\Windows\CurrentVersion\Explorer\FileExts\',0
szApplication  db  'Applications\',0
szChoosePgm    db  'Rundll32.exe Shell32.dll,OpenAs_RunDLL ',0
szWordpad      db  'Wordpad.exe',0
szNotepad      db  'Notepad.exe',0
szPaint        db  'Pbrush.exe',0
szPaintXP      db  'Mspaint.exe',0
szControl      db  'Rundll32.EXE Shell32,Control_RunDLL',0
szDesktop      db  'ShowDesktop.scf',0
;---------- [Script to show desktop
;[Shell]
;Command=2
;IconFile=explorer.exe,3
;[Taskbar]
;Command=ToggleDesktop

szShort        db  'Shortcut',0
szLn           db  '.lnk',0
szShortcut     db  'Shortcut to ',0
szOpenWith     db  'Open Wit&h',0
szPaste        db  'Paste',0
szLnk          db  'lnk',0
szRes          db  'Res\',0
szBackI        db  'Back.ico',0
szFolderC      db  'FolderC.ico',0
szFolderO      db  'FolderO.ico',0

szRoot         db  'C:\',0
szDriveType    db  'a:\',0
szAll          db  '\*.*',0
szAllFiles     db  '*.*',0

szError1       db  'The CustList.DLL was not found!',0
szError2       db  'The above Path no longer exist.',0

szOpen         db  'open',0
szSendTo       db  'Send To',0
szTree         db  'Tree View',0
szRefresh      db  'Refresh',0
szSHParse      db  'SHParseDisplayName',0
;szProperties   db  'Properties',0

szNameCol      db  'Name',0
szExtCol       db  'Ext',0
szSizeCol      db  'Size',0
szDateCol      db  'Date',0
szAttrCol      db  'Attr',0

WndPos         dd  0, 0, 0, 0
SplitV         dd  0,163,165,476,478,789,311,311

DefCustColor   dd  00fffff4h,00003000h,00eaffeah,00ffffcdh,00c0f0c0h,00c4ffffh,
                   00edc7f8h,00c5c589h,00ffd000h,00ac5757h,000000a6h,00c000c0h,
                   0011d952h,00002200h,000045d5h,00ffffebh

DefaultColor   dd  00001616h,00c5c589h,00fffff4h,00fffff4h,00c8d0d4h,00005900h,
                   00ebe2d6h,00000000h,00404000h,00404000h

COLORS struct
   SelBarF     dd  00001616h  ; Selection Bar color
   ColumnBC    dd  00c5c589h  ; Column back ground color
   TreeBC      dd  00fffff4h  ; Tree back ground color
   ListBC      dd  00fffff4h  ; List back ground color
   Grid        dd  00c8d0d4h  ; Grid color
   Selection   dd  00005900h  ; Selection color
   SelInactive dd  00ebe2d6h  ; Inactive selection color
   ColumnTC    dd  00000000h  ; Column text color
   TreeTC      dd  00404000h  ; Tree text color
   ListTC      dd  00404000h  ; List text color
COLORS ends
Color          COLORS   <>

DATETIME struct
   dyrs        db  4 dup(?)    ; Used for sort
   dmo         db  2 dup(?)
               db  '/'
   dda         db  2 dup(?)
               db  '/'
   dyr         db  4 dup(?)
               db  ' '
   dhour       db  2 dup(?)
               db  ':'
   dmin        db  2 dup(?)
               db  ':'
   dsec        db  2 dup(?)
               db  0
DATETIME ends
cdt            DATETIME    <>

szSpace        db  ' ',0
szSpace2       db  '  ',0
szQuote        db  '"',0
szColon        db  ':',0
szSlashB       db  '\',0
szBL           db  '[',0
szBR           db  ']  ',0
szOf           db  ' of ',0
szKFree        db  ' k free',0
szCombo        db  '[- -]',0
szDir          db  '<DIR>',0
szBack         db  '[..]',0
szFill         db  '----',0
szDateL        db  '194108/19/1941 02:04:44',0
szIn           db  ' in ',0
szFiles        db  ' files selected',0
szEdit         db  'User &Edit',0
szChoose       db  'Choose Program...',0
szShortCut     db  'Create Shortcut To Desktop',0
szRename       db  'Rename',0
szRecyc        db  'RECYCLED',0
Exit           db  'E X I T',0 
Butt1          db  '   Copy',0
Butt2          db  '  Move',0
Butt3          db  'Rename',0
Butt4          db  ' Delete',0
Butt5          db  'Make Dir',0
Butt6          db  '   Find',0

CopyFiles      db  '(',0
CopyNum        db  4 dup(' ')
Files          db  ') Files',0
szBytes        db  ' Bytes,  ',0
sza            db  ' a ',0
szx            db  ' x ',0
szyo           db  ' -y-o',0
szw            db  ' -w',0
szr            db  ' -r',0
szExclude      db  ' -xTemp.*',0
szTemp         db  'TempArch',0
szNull         db  0

szDriveD       db  'Drive:',0
szVolD         db  'Vol:',0
szCopyD        db  'Copy:',0
szMoveD        db  'Move:',0
szPackD        db  'Pack:',0
szRenameD      db  'Rename:',0
szNiceDay      db  'Have A Nice Day!',0
szCreateD      db  'Create A New Directory',0
szDeleteD      db  'Are you sure you want to delete the selected Items\Directories ?',0
szNoSelect     db  'There are no file/folder Selection(s) !',0
szTooLong      db  'The new volume label is too long !',0
szArchive      db  ' for archiving',0

.data?
hInst          dd  ?
CommandLine    dd  ?
hCustListDLL   dd  ?
hShell32       dd  ?
hSHNotify      dd  ?
MainExit       dd  ?
hWnd           dd  ?
hAccel         dd  ?
hWndStat       dd  ?
hWndTool       dd  ?
hWndToolE      dd  ?
hWndToolN      dd  ?
hWndDrives     dd  ?
hWndToolC      dd  ?
hComboL        dd  ?
hComboR        dd  ?
hStaticT       dd  ?
hStaticL       dd  ?
hStaticR       dd  ?
hToolBarL      dd  ?
hToolBarR      dd  ?
hFill          dd  ?
hSelBarT       dd  ?
hSelBarL       dd  ?
hSelBarR       dd  ?
hSplitBar      dd  ?
hImageListD    dd  ?
hImageListN    dd  ?
hImageListT    dd  ?
hImageListTree dd  ?
hHeader        dd  ?
hWndTree       dd  ?
hWndListL      dd  ?
hWndListR      dd  ?
hSMenu         dd  ?
hSubMenu       dd  ?
hCopy          dd  ?
hFontC         dd  ?
hFontL         dd  ?
hFontM         dd  ?
hFontS         dd  ?
hFontT         dd  ?
hSplit         dd  ?
hDrag          dd  ?
hDrop          dd  ?
hBrush         dd  ?
hImageList     dd  ?
hImageListL    dd  ?
hImageListR    dd  ?
hSingleImage   dd  ?
hImageAssoc    dd  ?
SavButtL       dd  ?
SavButtR       dd  ?
DragOn         dd  ?
BarType        dd  ?
ActiveList     dd  ?
ViewFlag       dd  ?
EqualOn        dd  ?
PaintOn        dd  ?
FolderOn       dd  ?

ListTotS       dd  ?
ListTotSL      dd  ?
ListTotSR      dd  ?
ListTotN       dd  ?
ListTotNL      dd  ?
ListTotNR      dd  ?

ListSelS       dd  ?
ListSelSL      dd  ?
ListSelSR      dd  ?
ListSelN       dd  ?
ListSelNL      dd  ?
ListSelNR      dd  ?
ListSelTot     dd  ?

NumColumns     dd  ?
Column01       db  64  dup(?)
Column02       db  64  dup(?)
Column03       db  64  dup(?)
Column04       db  64  dup(?)
Column05       db  64  dup(?)
Column06       db  64  dup(?)

NumPgms        dd  ?
Pgm01          db  64  dup(?)
Pgm02          db  64  dup(?)
Pgm03          db  64  dup(?)
Pgm04          db  64  dup(?)
Pgm05          db  64  dup(?)
Pgm06          db  64  dup(?)
Pgm07          db  64  dup(?)
Pgm08          db  64  dup(?)
Pgm09          db  64  dup(?)

.data
ColPathArray   dd  szListPathL,szListPathR
ColTextArray   dd  Column01,Column02,Column03,Column04,Column05,Column06
PgmTextArray   dd  Pgm01,Pgm02,Pgm03,Pgm04,Pgm05,Pgm06,Pgm07,Pgm08,Pgm09

szExt01        db  '.acm',0
szExt02        db  '.asm',0
szExt03        db  '.ax',0
szExt04        db  '.avi',0
szExt05        db  '.bat',0
szExt06        db  '.bmp',0
szExt07        db  '.cab',0
szExt08        db  '.chm',0
szExt09        db  '.com',0
szExt10        db  '.cpl',0
szExt11        db  '.dat',0
szExt12        db  '.def',0
szExt13        db  '.dll',0
szExt14        db  '.doc',0
szExt15        db  '.emf',0
szExt16        db  '.fon',0
szExt17        db  '.gif',0
szExt18        db  '.hlp',0
szExt19        db  '.html',0
szExt20        db  '.inc',0
szExt21        db  '.inf',0
szExt22        db  '.ini',0
szExt23        db  '.jpg',0
szExt24        db  '.lib',0
szExt25        db  '.log',0
szExt26        db  '.mov',0
szExt27        db  '.mpg',0
szExt28        db  '.nam',0
szExt29        db  '.nls',0
szExt30        db  '.ocx',0
szExt31        db  '.png',0
szExt32        db  '.pus',0
szExt33        db  '.rc',0
szExt34        db  '.reg',0
szExt35        db  '.rtf',0
szExt36        db  '.sys',0
szExt37        db  '.txt',0
szExt38        db  '.tsp',0
szExt39        db  '.ttf',0
szExt40        db  '.uce',0
szExt41        db  '.vxd',0
szExt42        db  '.wmf',0
ExtArray       dd  szExt01,szExt02,szExt03,szExt04,szExt05,szExt06,szExt07,szExt08,szExt09,szExt10,
                   szExt11,szExt12,szExt13,szExt14,szExt15,szExt16,szExt17,szExt18,szExt19,szExt20,
                   szExt21,szExt22,szExt23,szExt24,szExt25,szExt26,szExt27,szExt28,szExt29,szExt30,
                   szExt31,szExt32,szExt33,szExt34,szExt35,szExt36,szExt37,szExt38,szExt39,szExt40,
                   szExt41,szExt42
; To add
; 

OneK       REAL10  1024.0

.data?
AvailQ      QWORD  ?
TotalQ      QWORD  ?
TFreeQ      QWORD  ?
AvailD         dd  ?
TotalD         dd  ?

ColWth         dd  6   dup(?)

TextLen01      dd  ?
TextLen02      dd  ?
TextLen03      dd  ?
TextLen04      dd  ?
TextLen05      dd  ?
TextLen06      dd  ?

lpType         dd  ?
lpcbData       dd  ?
lpdwDisp       dd  ?
lpcbValueName  dd  ?
lpcValues      dd  ?

hDefHeap       dd  ?
hBuff          dd  ?
hPathL         dd  ?
hPathR         dd  ?

Funct          dd  ?
FunctT         dd  ?
sbParts        dd  3   dup(?)
SelArray       dd  512 dup(?)
pShellMalloc   dd  ?
Cmd            dd  ?
pshf           dd  ?
pidlBase       dd  ?
MenuCnt        dd  ?
NumDrives      dd  ?
ListHgt        dd  ?
DropOn         dd  ?
GoBackOn       dd  ?
TreeviewOn     dd  ?
CollaspeOn     dd  ?
NotifyOn       dd  ?
HitList        dd  ?
HitRow         dd  ?
FileOper       dd  ?
DragToTree     dd  ?
DragFrTree     dd  ?
DragInTree     dd  ?
DragMode       dd  ?
FileTyp        dd  ?
ProgPos        dd  ?
DupeCode       dd  ?
ChkZip         dd  ?
SelBarMask     dd  ?
dwTop          dd  ?
ImageID        dd  ?
hDragImageList dd  ?
WBottom        dd  ?
LBottom        dd  ?
pcm2           dd  ?
SavRow         dd  ?

SortL          dd  2   dup(?)
SortR          dd  2   dup(?)
CntL           dd  ?
CntR           dd  ?
FillL          dd  ?
FillR          dd  ?
CustClrs       dd  16  dup(?)
ImageIDS       dd  100 dup(?)
DriveArrayI    dd  30  dup(?)

DriveArrayL    db  30  dup(?)
szDrv          db  5   dup(?)
szWork         db  64  dup(?)
szPath         db  256 dup(?)
szPathL        db  256 dup(?)
szPathR        db  256 dup(?)
szListPathL    db  256 dup(?)
szListPathR    db  256 dup(?)
szStatusL      db  64  dup(?)
szStatusR      db  64  dup(?)
szFolder       db  256 dup(?)
szFileName     db  256 dup(?)
szExt          db  24  dup(?)
szWordPath     db  256 dup(?)
szPathName     db  256 dup(?)
szRootPath     db  256 dup(?)
szListFrom     db  256 dup(?)
szBuffFr       db  256 dup(?)
szBuffFrST     db  256 dup(?)
szBuffTo       db  256 dup(?)
szBuffToST     db  256 dup(?)
szPastePath    db  256 dup(?)

Test33         dd  ?
Test44         dd  ?
;SavItem        dd  ?

;---------- [Structures] ----------
; Column structure
COLUMN struct
   lpszPath    dd  ?          ; Pointer to list path text.
   ColWth      dd  ?          ; Column width.
   lpszhdrtext dd  ?          ; Pointer to header text.
   HeaderAlign dd  ?          ; Header text alignment.
   ColumnAlign dd  ?          ; Column text alignment.
   ColumnType  dd  ?          ; Column data type.
   MaxLen      dd  ?          ; Max text lenght for TYPE_EDITTEXT and TYPE_EDITLONG.
   lpszFormat  dd  ?          ; Format string for TYPE_EDITLONG.
   hImageList  dd  ?          ; Handle of image list. For the image columns and combobox only.
   SortFlag    dd  ?          ; Sort flags.
   SortAD      dd  ?          ; Sort ascending decending.
   ColNum      dd  ?          ; Column number
   Colxp       dd  ?          ; Column position. Internally used.
   EditWnd     dd  ?          ; Column control handle. Internally used.
COLUMN ends

; Notifications
LISTNOTIFY struct
   nmhdr       NMHDR <?>
   Col         dd  ?          ; Column
   Row         dd  ?          ; Row
   hwnd        dd  ?          ; Handle of the column edit control
   hList       dd  ?          ; Handle of the active list control
   DragOn      dd  ?          ; Start drag
   HitList     dd  ?          ; Left or Right list
   HitRow      dd  ?          ; Target row
   RButt       dd  ?          ; Right button down
   DBClick     dd  ?          ; Left button double click
   FileTyp     dd  ?          ; File type e.g. GoBack. Dir, File
   SortFlag    dd  ?          ; Sort flags.
   lpdata      dd  ?          ; Pointer to data
   fcancel     dd  ?          ; Set to TRUE to cancel operation
LISTNOTIFY ends

ROWDATA struct
   lpName      dd  ?          ; Data for Filename column. Pointer to string
   lpExt       dd  ?          ; Data for Ext column. Pointer to string
   lpSize      dd  ?          ; Data for Size column. Pointer to string
   lpDate      dd  ?          ; Data for Date column. Pointer to string
   lpAttr      dd  ?          ; Data for Attributes column. Pointer to string
   Index       dd  ?          ; Image ID & File type e.g. folder, file
ROWDATA ends

HANDLES struct
   hWnd        dd  ?          ; Main window
   hWndStat    dd  ?          ; Status bar
   hWndListL   dd  ?          ; List left
   hWndListR   dd  ?          ; List right
   hWndTree    dd  ?          ; Treeview
   hImageList  dd  ?          ; Imagelist
HANDLES ends
Hand           HANDLES              <>

HPATH struct
   szPath      db  256 dup(?) ; Left paths
HPATH ends

.data
CLSID_ShellLink     GUID       sCLSID_ShellLink
IID_IShellLink      GUID       sIID_IShellLink
IID_IPersistFile    GUID       {00000010bH, 00000H, 00000H, \
                               {0C0H, 000H, 000H, 000H, 000H, 000H, 000H, 046H}}
.data?
IID struct
   Data1       dd ?
   Data2       dw ?
   Data3       dw ?
   Data4       db 8 dup(?)
IID ends

externdef      IID_IMalloc:IID          
externdef      IID_IShellFolder:IID
externdef      IID_IContextMenu:IID
externdef      IID_IContextMenu2:IID

;IID_IContextMenu GUID sIID_IContextMenu
LPITEMIDLIST   typedef PTR ITEMIDLIST
LPPITEMIDLIST  typedef PTR LPITEMIDLIST

pContextMenu2	LPCONTEXTMENU2 ?

g_szPath       db  256 dup(?)
SFGAOF typedef DWORD

SHChangeNotifyRegister        typedef proto :DWORD, :DWORD, :DWORD, :DWORD, :DWORD, :ptr LPITEMIDLIST
SHChangeNotifyUnregister      typedef proto :DWORD
protoSHParseDisplayName	      typedef proto :ptr WORD, :DWORD, :ptr LPITEMIDLIST, :SFGAOF, :ptr SFGAOF

LPFNSHCHANGENOTIFYREGISTER		typedef ptr SHChangeNotifyRegister
LPFNSHCHANGENOTIFYUNREGISTER	typedef ptr SHChangeNotifyUnregister
LPFNSHPARSEDISPLAYNAME			typedef ptr protoSHParseDisplayName

.data
lpSHChangeNotifyRegister	   LPFNSHCHANGENOTIFYREGISTER   NULL
lpSHChangeNotifyUnregister	   LPFNSHCHANGENOTIFYUNREGISTER NULL
lpfnSHParseDisplayName        LPFNSHPARSEDISPLAYNAME       NULL
.data?
;IMalloc struct
;   QueryInterface   dd  ?
;   AddRef           dd  ?
;   Release          dd  ?
;   Alloc            dd  ?
;   Realloc          dd  ?
;   Free             dd  ?
;   GetSize          dd  ?
;   DidAlloc         dd  ?
;   HeapMinimize     dd  ?
;IMalloc ends

;IShellFolder struct
;   QueryInterface   dd  ?
;   AddRef           dd  ?
;   Release          dd  ?
;   ParseDisplayName dd  ?
;   EnumObjects      dd  ?
;   BindToObject     dd  ?
;   BindToStorage    dd  ?
;   CompareIDs       dd  ?
;   CreateViewObject dd  ?
;   GetAttributesOf  dd  ?
;   GetUIObjectOf    dd  ?
;   GetDisplayNameOf dd  ?
;   SetNameOf        dd  ?
;IShellFolder ends

;IContextMenu struct
;   QueryInterface   dd  ?
;   AddRef           dd  ?
;   Release          dd  ?
;   QueryContextMenu dd  ?
;   InvokeCommand    dd  ?
;   GetCommandString dd  ?
;IContextMenu ends

IPersistFile struct
   IPersistFile_QueryInterface       comethod3 ?
   IPersistFile_AddRef               comethod1 ?
   IPersistFile_Release              comethod1 ?
   IPersistFile_GetClassID           comethod2 ?
   IPersistFile_IsDirty              comethod1 ?
   IPersistFile_Load                 comethod3 ?
   IPersistFile_Save                 comethod3 ?
   IPersistFile_SaveCompleted        comethod2 ?
   IPersistFile_GetCurFile           comethod2 ?
IPersistFile ends

LV_OBJDATA struct
   pshfParent    dd  ? ;LPSHELLFOLDER  ?
   pidlRel       dd  ? ;LPITEMIDLIST   ?
   pidlFull      dd  ? ;LPITEMIDLIST   ?
   dwAttr        dd  ?
   iItem         dd  ?
   sBack         dd  ?
LV_OBJDATA ends
LPLV_OBJDATA typedef ptr LV_OBJDATA
LPPLV_OBJDATA typedef ptr LPLV_OBJDATA

lf             LOGFONT              <?>
time           SYSTEMTIME           <>
icc            INITCOMMONCONTROLSEX <?>
mis            MEASUREITEMSTRUCT    <?>
dis            DRAWITEMSTRUCT       <?>
mii            MENUITEMINFO         <?>
tvht           TV_HITTESTINFO       <>
tvins          TV_INSERTSTRUCT      <>

;include TreeList.asm
